#ifndef __UB_OOM_H_
#define __UB_OOM_H_

#include <ub/ub_decl.h>

/* oom killer */
UB_DECLARE_VOID_FUNC(ub_oom_init(void))
UB_DECLARE_FUNC(int, ub_oom_start(void))
UB_DECLARE_FUNC(struct user_beancounter *, ub_oom_select_worst(void))
UB_DECLARE_VOID_FUNC(ub_oom_kill_task(struct task_struct *tsk,
			struct mm_struct *mm))
UB_DECLARE_VOID_FUNC(ub_oom_stop(void))
UB_DECLARE_VOID_FUNC(ub_oom_task_exit(struct task_struct *tsk))

#ifdef CONFIG_USER_RESOURCE
#define ub_oom_task_match(t, ub)	(((ub) == NULL) || \
			((t)->mm != NULL && (t)->mm->mm_ub == (ub)))
#define ub_oom_panic(ub)		((ub) == NULL)
#else
#define ub_oom_task_match(t, ub)	1
#define ub_oom_panic(ub)		1
#endif

/* vmscan stuff */
struct scan_control;
struct oom_freeing_stat {
	unsigned long free;
	unsigned long swap; /* page referrence counters removed */
	unsigned long write; /* IO started */
	unsigned long slab;   /* slabs shrinked */
};

#ifdef CONFIG_USER_RESOURCE
#define ub_oom_inc(sc, res, nr)	do { (sc)->oom_stat.res += nr; } while (0)
#define ub_oom_did_progress(sc)	(nr_swap_pages && (	\
		(sc)->oom_stat.slab ||			\
		(sc)->oom_stat.swap ||			\
		(sc)->oom_stat.write ||			\
		(sc)->oom_stat.free			\
	))
#else
#define ub_oom_inc(sc, res, nr)	do { } while (0)
#define ub_oom_did_progress(sc)	0
#endif
#endif
